from typing import Optional

import axipy


def from_mapinfo(mapbasic_string: str) -> Optional[axipy.Style]:
    """
    Получает стиль из строки формата MapBasic.

    Args:
        mapbasic_string: Строка в формате MapBasic.
    """

    shadow = axipy.cpp_core_geometry.ShadowStyle.from_mapinfo(mapbasic_string)
    if shadow is None or shadow.isEmpty():
        return None

    if isinstance(shadow, axipy.cpp_core_geometry.ShadowStyle):
        style = object.__new__(axipy.Style)
        style._shadow = shadow
        return style

    return axipy.Style._wrap(shadow)