import os

from PySide2 import QtGui
from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QListWidgetItem, QHBoxLayout, QLayout
from axipy import *

from StyleTools.controls.compositeStyle.ui.StyleComposite.widgetTextStyle import styleWidgetText
from StyleTools.controls.compositeStyle.ui.StyleComposite.widgetsItem import styleWidget


class StylesComposite(QWidget):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.ui=self.load_ui("widgetMain2.ui",parent)
        self.__initUi()
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def __initUi(self):
        geo_point=Point(0,0)
        style_point=Style.for_geometry(geo_point)
        mi_style_point=style_point.to_mapinfo()
        self.__cls_widget_point=styleWidget("Стиль точечных объектов",style_point,self.ui.groupBox_point)
        self.ui.form_point.addWidget(self.__cls_widget_point)
        #self.__addWidget(self.__cls_widget_point)
        geo_line=Line(Pnt(0,0),Pnt(1,1))
        style_line=Style.for_geometry(geo_line)
        self.__cls_widget_line = styleWidget("Стиль линейных объектов", style_line, self.ui.groupBox_line)
        self.ui.form_line.addWidget(self.__cls_widget_line)
        #self.__addWidget(self.__cls_widget_line)
        rect_geo= Rectangle(0, 0, 40, 20)
        style_poly=Style.for_geometry(rect_geo)
        self.__cls_widget_poly=styleWidget("Стиль площадных объектов", style_poly, self.ui.groupBox_brush)
        self.ui.form_brush.addWidget(self.__cls_widget_poly)
        r = Rect(8, 6, 11, 7)
        geo_text = Text("Пример\nтекста", rect=r)
        style_text=Style.for_geometry(geo_text)
        self.__cls_widget_text = styleWidgetText("Стиль текстовых объектов", style_text, self.ui.groupBox_text)
        self.ui.form_text.addWidget(self.__cls_widget_text)
    def __addWidget(self,widget):
        itemN = QListWidgetItem()
        widgetLayout = QHBoxLayout()
        widgetLayout.addWidget(widget)

        widgetLayout.addStretch()

        widgetLayout.setSizeConstraint(QLayout.SetFixedSize)
        #widget.setLayout(widgetLayout)
        itemN.setSizeHint(widget.sizeHint())
        self.ui.listWidget.addItem(itemN)
        self.ui.listWidget.setItemWidget(itemN, widget)

    @property
    def widget(self):
        return self.ui
