from osgeo import ogr

from EditCustomSymbol.Test.TestReadMapinfoFnt.mapinfo_fnt import factoryImportMapInfoFnt
from StyleTools.controls.pointStyleEditor.ui.add_tools.DbTools.SqliteDataSource import DbSqliteDataSource, \
    addFeatyreToLayer


def createPolyline(points):
    line = ogr.Geometry(ogr.wkbLineString)
    for pnt in points:
        line.AddPoint(pnt[0],pnt[1])
    return line
def createPolygon(points):
    ring = ogr.Geometry(ogr.wkbLinearRing)
    for pnt in points:
        ring.AddPoint(pnt[0],pnt[1])
    poly = ogr.Geometry(ogr.wkbPolygon)
    poly.AddGeometry(ring)
    return poly
def prepareGeometryToOgr(list_geometry):
    type_geo=ogr.wkbPolygon
    ft_ogr=[]
    for s_geo in list_geometry:
        ogr_geo=None
        mi_styel_att=None
        style=s_geo["style"]
        if s_geo['polygon']:
            ogr_geo=createPolygon(s_geo['points'])
            try:
                mi_styel_att=style['pen']+" "+style["brush"]
            except:
                mi_styel_att="Pen (1, 2, 0) Brush (1, 0, 0)"
        else:
            ogr_geo=createPolyline(s_geo['points'])
            mi_styel_att = style['pen']
            type_geo=ogr.wkbUnknown
        att=[]
        att.append({"mi_style":mi_styel_att})
        ft_ogr.append({"geometry":ogr_geo,"attribute":att})
    return type_geo,ft_ogr



path_db=r"E:\Support\AxiomaTesting\Symbol\DbStyle\style_fnt_full.gpkg"
cs_wkt='LOCAL_CS["Nonearth",UNIT["Millimeter",0.001],AXIS["Easting",EAST],AXIS["Northing",NORTH]]'
sp_db=DbSqliteDataSource()
sp_db.create(path_db,"GPKG")
sp_db.createCatalog()


path_fnt=r"C:\MapInfo\mi_12_5x32Professional\AddUser\mapinfow.fnt"
cls_fnt=factoryImportMapInfoFnt(path_fnt)
count_symbols=cls_fnt.countSymbols
table_info={'xmin':-30,'ymin':-30,'xmax':30,'ymax':30}
for i in range(count_symbols):
    id_sym=i
    geometrys=cls_fnt.getGeometrySym(id_sym)
    name_sym="symbl_"+"{:03d}".format(id_sym)
    print(name_sym)
    type_geo,ft=prepareGeometryToOgr(geometrys)
    '''
        layer=sp_db.createTable(name_sym,None,cs_wkt,type_geo)
        addFeatyreToLayer(layer,ft)
        layer=None
    '''

    sp_db.saveTable(name_sym,table_info,ft,None,cs_wkt,type_geo)
sp_db.close()
print("end")

