import os

import axipy
from PySide2.QtGui import QIcon
from axipy import Plugin, view_manager

from StyleTools.controls.pointStyleEditor.ui.docWidget import AxiDocWidget
from StyleTools.controls.pointStyleEditor.ui.docWidget import DelDocWidget, addDoc, existDocWidget
from StyleTools.controls.pointStyleEditor.ui.main_widget import main_Form


class ControlPointStyle:
    __title="Редактор точечных стилей"
    __def_name_group = "Стили"
    __name_doc = "Редактор точечных стилей"
    def __init__(self,parent_plugin:Plugin):
        self.__form_tool=None
        self.__docWidget=None
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'edit.png')
        self.__action=parent_plugin.create_action(self.__title,icon=local_file_icon,on_click=self.__run)
    def __run(self):
        if self.__form_tool is None:
            self.__name="Композитные стили"
            self.__form_tool =main_Form(view_manager.global_parent)

        if self.__docWidget is None:

            self.__docWidget = AxiDocWidget(self.__form_tool.widget, self.__name_doc, self.__name_doc,
                                            QIcon(), view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist = existDocWidget(view_manager.global_parent, self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()

    @property
    def name(self):
        return self.__name

    @property
    def name_group(self):
        return self.__def_name_group

    @property
    def action(self):
        return self.__action
    def unload(self):
        if self.__docWidget is not None:
            DelDocWidget(view_manager.global_parent, self.__docWidget)
            # self.__observer.removeChildrenWidget(self.__name_observer)
            self.__docWidget.setVisible(False)
            self.__docWidget = None
            self.__form_tool = None
        self.__action.remove()
