import os

from PySide2.QtCore import QMetaObject, QCoreApplication, QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QVBoxLayout, QWidget, QToolBox

from StyleTools.controls.pointStyleEditor.ui.add_tools.helper_tab import openTabSqlite
from StyleTools.controls.pointStyleEditor.ui.add_tools.map_style import MapVectroStyle
from StyleTools.controls.pointStyleEditor.ui.wdigetStyleDb import WidgetDbStyle
from StyleTools.controls.pointStyleEditor.ui.widgetCopyStyle import CopyStyle
from StyleTools.controls.pointStyleEditor.ui.widgetmapControl import MapControlWidget


class main_Form(QWidget):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.__default_size=60
        self.ui=self.load_ui("main_widget.ui",parent)

        self.__toolbox = QToolBox()
        count=self.__toolbox.count()
        self.ui.verticalLayout_main.addWidget(self.__toolbox)
        self.__dbStyle=WidgetDbStyle(self.__toolbox)
        self.__controlMap=MapControlWidget(self.__dbStyle,self.__toolbox)
        self.__controlMap.end_signal.connect(self.__end_edit)
        self.__dbStyle.edit_signal.connect(self.__edit_symbol)
        self.__copyStyle=CopyStyle(self.__dbStyle,self.__toolbox)
        self.__copyStyle.save_signal.connect(self.__change_status_auto_sync)
        #self.__toolbox.addItem(self.__dbStyle,"База точечных стилей")
        #self.__toolbox.addItem(self.__copyStyle, "Запись")
        #count = self.__toolbox.count()
        #self.__toolbox.insertItem(0,self.__dbStyle,"База точечных стилей")
        self.__toolbox.setItemText(0,"База точечных стилей")
        self.__toolbox.setItemText(1, "Редактирование стиля")
        self.__toolbox.setItemText(2, "Запись")
        self.__toolbox.setItemEnabled(1,False)
        #self.__toolbox.itemRemoved(1)
        #count = self.__toolbox.count()
        self.__dbStyle.ui.tb_add.clicked.connect(self.__add_style)
        jkl=0
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui

    @property
    def widget(self):
        return self.ui
    def __add_style(self):
        ''' Добавляем новый символ'''
        if not self.__dbStyle.IsOpenDb:
            return
        self.__toolbox.setItemEnabled(1, True)
        self.__toolbox.setItemEnabled(0, False)
        self.__toolbox.setCurrentIndex(1)
        name_new_symbol=self.__dbStyle.getMaxId()
        cs=MapVectroStyle.cretateCs(self.__default_size)
        layer=self.__dbStyle.spatialDb.createTable(name_new_symbol,None,cs.wkt)
        layer=None
        path_db=self.__dbStyle.pathDb
        tab_new_symbol=openTabSqlite(path_db,name_new_symbol)
        self.__controlMap.createMap(tab_new_symbol,self.__default_size)
    def __edit_symbol(self,name_symbol):
        path_db = self.__dbStyle.pathDb
        tab_new_symbol = openTabSqlite(path_db, name_symbol)
        self.__toolbox.setItemEnabled(1, True)
        self.__toolbox.setItemEnabled(0, False)
        self.__toolbox.setCurrentIndex(1)
        self.__controlMap.createMap(tab_new_symbol, self.__default_size)
    def __end_edit(self):
        self.__toolbox.setItemEnabled(0, True)
        self.__toolbox.setItemEnabled(1, False)
        self.__toolbox.setCurrentIndex(0)
    def __change_status_auto_sync(self,list_parm):
        self.__controlMap.setPathOut(list_parm[0],list_parm[1])
